import 'package:rxdart/rxdart.dart';
import 'dart:async';

class AdeptPublishSubject<T>{
  PublishSubject<T> _publishSubject;
  T _value;
  T get value => _value;

  AdeptPublishSubject() : _publishSubject = PublishSubject<T>();


  void post(T value) => _publishSubject.add(_value = value);
  Observable<T> stream() => _publishSubject.stream;
  StreamSubscription<T> listen(void onData(T event), {Function onError, void onDone(), bool cancelOnError}) =>
    _publishSubject.stream.listen(onData, onError: onError, onDone: onDone, cancelOnError: cancelOnError);

  void close() => _publishSubject.close();
}